// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022 Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



using System;
using System.Threading;

namespace Hiperscan.ApoIdentCore.ActionControl
{
    public class GuiActionSync
    {
        public void Enter(ApoActionArg arg)
        {
            arg.UpdateIsFinished = false;

            this.Sync.WaitOne();
        }

        public void Leave(ApoActionArg arg)
        {
            arg.UpdateIsFinished = true;
        }

        public void Wait(ApoActionArg arg)
        {
            for (; ; )
            {
                if (arg.UpdateIsFinished == true)
                {
                    this.Sync.Release();
                    break;
                }

                System.Threading.Thread.Sleep(50);
            }
        }

        private Semaphore Sync { get; set; } = new Semaphore(1, 1);
    }
}
